$Id: History,v 1.131 2010/06/07 05:40:46 perl Exp $
----------------------------------------------------

     =========================================================
     Geant4 - an Object-Oriented Toolkit for Simulation in HEP
     =========================================================

                    TestEm3 History file
                    --------------------
This file should be used by the G4 example coordinator to briefly
summarize all major modifications introduced in the code and keep
track of all tags.

     ----------------------------------------------------------
     * Reverse chronological order (last date on top), please *
     ----------------------------------------------------------
     
06-06-10 J.Perl (testem3-V09-03-04)
- Remove unused variable in EventAction

03-06-10 J.Perl (testem3-V09-03-03)
- Updated vis usage 
    
19-05-10 mma (testem3-V09-03-02)
- TestEm3.cc : introduction of G4UIExecutive

13-04-10 V.Ivant (testem3-V09-03-01)
- PhysicsList - removed obsoleted unused include 

24-01-10 V.Ivant (testem3-V09-03-00)
- Added PhysListEmStandardGS and PhysListEmStandardWVI
- Added printout of mean number of gamma, e-, e+ 
     
13-11-09 mma (testem3-V09-02-02)
- PhysListEmStandard.cc (local): eMultipleScattering -> UrbanMscModel93
- PhysicsList : remove G4EmConfigurator
     
17-09-09 mma (testem3-V09-02-01)
- PhysicsList.cc :
  - renamed "standard" -> "local"; "emstandard" -> "emstandard_opt0" 
  - Substituted obsolete low-energy physics builders by builders from
    the physics_list library;
- updated README and macro files  
  
- PhysicsList - added option "emstandard_msc91" (V.Ivant)
     
04-03-09 mma (testem3-V09-02-00)
- HistoManager::PrintHisto() : avoid empty ascii file
     
16-11-08 mma (testem3-V09-01-12)
- Em options: 20bins/decade  LinLossLimit=default=0.01
     
11-11-08 mma (testem3-V09-01-11)
- update again PhysListEmStandard : number of bins and LinLossLimit
      
31-10-08 mma (testem3-V09-01-10)
- Use G4hMultipleScattering for muons and protons
- Modify EM options 
     
22-10-08 mma (testem3-V09-01-09)
- update PhysListEmStandard and README

16-10-08 V.Ivant (testem3-V09-01-08)
- Removed temporary builders PhysListEmStandardLPM and 
PhysListEmStandardIG
     
13-09-08 mma(testem3-V09-01-07)
- HistoManager  : change default format

12-06-08 mma (testem3-V09-01-06)
- Remove AIDA from GNUmakefile 

28-05-08 V.Ivant (testem3-V09-01-05)
- Added PhysListEmStandardLPM - PhysLists with high energy 
    bremsstrahlung model
- Improved printout
     
05-05-08 mma (testem3-V09-01-04)
- PhysListEmStandard : add spline option for physics tables
- README : update Aida informations
     
07-04-08 mma (testem3-V09-01-03)
- HistoManager::saveAscii() : redefinition of binEdge
     
04-04-08 mma (testem3-V09-01-02)
- PhysicsList : add emstandard_opt3
- PhysListEmStandard : add G4eMultipleScattering; complete EmOptions
- SteppingAction : suppress reference to G4EmSaturation
     
14-03-08 mma (testem3-V09-01-01)
- DetectorConstruction : define Birks constant in materials (scintillator)

14-02-08 V.Ivant (testem3-V09-01-00)
- added line with beam particle type and its energy

13-11-07 V.Ivant (testem3-V09-00-02)
- added PhysListEmStandardIG experimental PhysList

12-11-07 mma (testem3-V09-00-01) 
- HistoManager/HistoMessenger : print selected histos on ascii file

02-07-07  V.Ivant (testem3-V09-00-00)
- update TestEm3.in in order to have the same options as before
     
22-06-07  mma (testem3-V08-03-02)
- more options in PhysListEmStandard
- cosmetic in TestEm3.cc

18-05-07  V.Ivant (testem3-V08-03-01)
- update macro files

16-05-07  V.Ivant (testem3-V08-03-00)
- use renamed EM builders

25-04-07  V.Ivant (testem3-V08-02-04)
- fix compilation problem at SUN

24-04-07  V.Ivant (testem3-V08-02-03)
- add command "/testem/run/limitEdep" allowing to compute restricted
  mean values to supress big statistical fluctuations
- update command "/testem/run/acceptance"
- skin=1 is a default PhysList

06-04-07  mma (testem3-V08-02-02)
- add macro emtutor.mac
- pl names : penelope, livermore
- restaure random seed storage
  
19-03-07  V.Ivant (testem3-V08-02-01)
  return back Z-position computation;

19-03-07  V.Ivant (testem3-V08-02-00)
- By default do not store random seed;
  add G4standard_exp PhysList;
  add material Lucite;
  do not activate VisManager in batch.

22-11-06  V.Ivant (testem3-V08-01-01)
- Fix names of standard EM builders
     
31-10-06 mma (testem3-V08-01-00) 
- flag LOADLIBS in GNUmakefile
- remove physics lists 52 and 71 
    
02-06-06 mma (testem3-V08-00-04)
- SteppingAction: replace Touchable by TouchableHandle
    
19-05-06 mma (testem3-V08-00-03)
- SteppingAction: prePoint->GetTouchable->GetVolume()
                  prePoint->GetTouchable->GetCopyNumber(depth)
     
19-05-06 mma (testem3-V08-00-02)
- update README

16-04-06 V.Ivant (testem3-V08-00-01) 
- add extra material and use G4 NIST element DB
- fix compilation warnings in HistoManager
- add Livermore and Penelope PhysicsLists

20-03-06 mma (testem3-V08-00-00)
- migration mum -> um in many macros

06-12-05 Gabriele Cosmo
- Trivial changes for support of CLHEP-2.0.X series.

22-11-05 mma (testem3-V07-01-04)
- correct bug in lateral leakage calculation (stepping action)
- introduce TrackingAction for energy flow initialization
- modify energy flow calculation in geant3
- update README

17-11-05 G.Cosmo (testem3-V07-01-03) 
- corrected fixes for migration to <sstream> to fix compilation
  errors on SUN-CC.

12-11-05 V.Ivant (testem3-V07-01-02) 
- fix compilation problems with streams
     
17-10-05 mma (testem3-V07-01-01) 
- modify energy flow calculation
     
07-10-05 mma (testem3-V07-01-00)
- create PhysListEmG4v71 (g4v71) for G4MultipleScattering71
     
01-06-05 mma (testem3-V07-00-08)
- HistoManager: option "--noErrors" for hbook
    
20-05-05 mma (testem3-V07-00-07)
- forward and backward energy flow in geant3
     
17-05-05 mma (testem3-V07-00-06)
- forward and backward energy flow: SteppingAction + RunAction
- photon processes '52'.
     
3rd May 2005  John Allison  (examples-V07-00-03)
- Replaced vis manager with G4VisExecutive.

15-03-05 mma (testem3-V07-00-05)
- remove He3 from predefined particles.
- PhysListEmStandard : treat Alpha as GenericIon
     
01-03-05 mma (testem3-V07-00-04)
- HistoManager : - put a protection for the creation of analysis factory;
                 - file extension is fileType;
- HistoMessenger : new command setFileOption 
     
22-02-05 V.Ivant (testem3-V07-00-03)
- MaxStep : fix infinite loop
     
02-02-05 mma 
- SteppingAction : sum charged stepLenght, even if edep=0.
     
11-01-05 mma (testem3-V07-00-02)
- SteppingAction : corrections for energy flow
- new macros linac.mac and geant3/linac.dat

11-01-05 V.Ivant (testem3-V07-00-01)
- Optimise StepMax and SteppingAction
     
07-01-05 mma (testem3-V07-00-00)
- update RunAction::PrintDedxTables() and ug3g4.F
     
03-12-04 mma (testem3-V06-02-06)
- update macros tbhec and lhcb

02-12-04 V.Ivant (testem3-V06-02-05)
- Migration to cmath
     
24-11-04 mma (testem3-V06-02-04)
- commit in cvs StepMax process and its messenger
     
23-11-04 mma (testem3-V06-02-03)
- implementation of StepMax process and its messenger. Remove the use of
  G4UserLimits in DetectorConstruction.
- fill edep histograms only if edep > 0.
     
25-10-04 mma (testem3-V06-02-02)
- more histograms : longitudinal energy profile and forward energy flow.

20-10-04 mma (testem3-V06-02-01)
- change the numering of absorbers:  start from 1 instead of 0
- modify all macros according to the above.
- do not delete AnalysisFactory (for Jaida).
- define correctly all UI subdirectories.

19-07-04 mma (testem3-V06-02-00)
- modifs in HistoManager and messenger to conform to testem5-V06-01-04 
- remove static ionC12. Use generic ion instead.
     
21-06-04  mma (testem3-V06-01-04)
- remove direct interface to ROOT
     
15-06-04  mma (testem3-V06-01-03)
- introduction of the class HistoManager (like TestEm5)
- EndOfRun: missprint in rms of totalTrackLength
     
09-06-04  mma (testem3-V06-01-02)
- move acceptance check in RunAction
- printout : remove leakage information
     
25-05-04 V.Ivanchenko
- Update printout
- Fix problem of dE/dx printout
- Add acceptance check activated by UI command

28-04-04 mma (testem3-V06-01-01)
- print resolution at EndOfRun
- suppress PhysListParticles and General
     
31-03-04 mma (testem3-V06-01-00)
- README : more informations about ROOT installation
     
17-03-04 mma (testem3-V06-00-02)
- energy leakage only from secondaries.
- idem in geant3
- suppression of DataVector in EventAction
- new macro dedx.max to quickly check dE/dx calculation
     
15-03-04 mma (testem3-V06-00-01)
- example of histograms with ROOT: USE_ROOT

21-01-04 mma
- possibility to have one histograms file per run.
- RunAction: removed ApplyCommand("/vis/...") statements.

28-11-03 V.Ivanchenko (testem3-V05-02-08)

27-11-03 V.Ivanchenko (testem3-V05-02-07)
- Fix memory corruption in the test

25-11-03 V.Ivanchenko (testem3-V05-02-06)
- Fix geometry (G.Cosmo)
     
13-11-03 John Allison
- Removed OPACS from Vis Manager.

03-11-03 mma (testem3-V05-02-05)
- add an estimation of the mean energy leaving each absorber

24-10-03 mma (testem3-V05-02-04)
- PhysListEmStandard: AddProcess(Bremsstrahlung,-1,3,3) ..etc..
     
06-10-03 mma (testem3-V05-02-03)
- Complete migration to model EM physics
- Class EmModel renamed G4v52.

25-09-03 mma (testem3-V05-02-02)
- forgotten to update GNUmakefile for G4ANALYSIS_USE

23-09-03 mma (testem3-V03-02-01)
- update exoNN.mac
- comment dawnfile in vis.mac

22-09-03 mma (testem3-V05-02-00)
- suppression of Em3 in all class names.
- materials: Silicium->Silicon.
- command setHisto : unit must be given.
- suppression of hits collection.
- replace G4NOHIST by G4ANALYSIS_USE
- most macro updated and renamed according the authors of experimental results.
- adapt geant3

18-06-03 G.Cosmo (testem3-V05-01-03)
- Em3RunAction.cc: removed usage of G4USE_STD_NAMESPACE after
  migration from G4std.

03-06-03 V.Ivanchenko (testem3-V05-01-02)
- Fix compilation warnings

15-05-03 V.Ivanchenko (testem3-V05-01-01)
- Proper deletion of old geometry when it is updated

09-05-03 V.Ivanchenko (testem3-V05-01-00)
- Change update command

10-04-03 mma (testem3-V05-00-05)
- define material BGO
- RunMessenger: enlarge allowed range for histos.
     
28-03-03 mma (testem3-V05-00-04)
- G4PVPlacement and G4PVReplica in logical mother

17-03-03 V.Ivant (testem3-V05-00-02)
- Additional migrade to cut per region
- Update modular PhysicsList

10-03-03 mma
- change in all macros: /run/particle/setCut -> /testem/phys/setCuts
- material CsI and example of SetMeanExcitationEnergy()
- example of static ion: IonC12 class and ionC12.mac

20-02-03 V.Ivant (testem3-V05-00-01)
- Migrade to cut per region
- Migrade to modular PhysicsList
- Add STD electromagnetic physics

12-02-03 mma (testem3-V05-00-00)
- DetectorConstruction : change volume name

05-12-02 mma (testem3-V04-01-01)
- migration to aida 3.0
- UI directory /testem/

05-12-02 cosmo (testem3-V04-01-00)
- Fixes to runAction for porting on gcc-3.2 compiler.
     
03-06-02 mma (testem3-V04-00-01)
- old histograming package clhep/hist replaced by AIDA 2.2/anaphe
     
14-02-02 mma (testem3-V04-00-00) 
- macros for em_exercices 
- Particle definition : G4Alpha 
       
28-11-01 mma (testem3-V03-02-03) 
- EventAction: DrawTrack "none"
- small change in vis.mac
- suppression of the rndm commands, now managed by G4RunManager: 
  --> RunAction, RunActionMessenger, EventAction.
  
39-10-01 mma (testem3-V03-02-02)
-invert initialize and update in all macros (and TestEm3.in)
     
25-10-01 mma (testem3-V03-02-01)
- GetEnergyCuts() in PrintdEdx()
     
22-10-01 mma (testem3-V03-02-00)
- mods in TestEm3.cc: the initialisation and vis initialisation are
  not done by default. --> inserted /run/initialize in all macros.
- To get visualisation: > /control/execute vis.mac
- 80 columns everywhere.   
     
19-10-01 Steve O'Neale (examples-V03-02-00)
- Update reference output

31-05-01 mma (testem3-V03-01-01)
- VisManager
     
30-05-01 mma
- in RunAction: method PrintDedxTables() : binning as Geant3,
  printout ready to be read as ffread data cards.
- Geant3 application in geant3/g4mat to read the above data cards,
  in order to compare G3 and G4 dE/dx tables (see README).   

13-04-01 mma (testem3-V03-01-00)
- In PrimaryGeneratorAction, possibility to randomize the beam spot
- command /gun/rndm in PrimaryGeneratorMessenger
- similar functionality in geant3: gukine.F
     
12-04-01 mma
- In DetectorConstruction, possibility to limit the step size, via
  a G4UserLimit object. 
- command /tracking/stepMax in DetectorMessenger
- data card STEPMX in geant3
       
06-04-01 mma
- in RunAction: method PrintDedxTables()
- in DetectorConstruction: Iron density corrected (was 7.7 g/cm3)
- in geant3: overwrite the computed radlength of scintillator 
	        
26-03-01 mma (testem3-V03-00-04)
- change in histogramming : 1d histo of Edep/Ebeam
  in each absorber instead of ntuple, both in G4 and G3.
- interactive command /run/setHisto (in G4) and ffread
  data card *histo (in G3) to control the binning of the histos.
- in G3, new data card CUTPR to set bcute, dcute, ppcutm for each tracking 
  medium
- in gnumakefile : the cpp flag g4nohist=true by default.
  --> no histograms in G4 by default. 
	  
	       
21-02-01 mma (testem3-V03-00-03)
- hbook histograms restored
	       
20-02-01 mma (testem3-V03-00-02)
- stepping verbose adapted for STL
- BirkAttenuation function
- save rndm at begin of event
     
07-12-00 mma (testem3-V02-00-03 & testem-noHist)
- remove hbook histograms: GNUmakefile,runAction,eventAction
				   
06-12-00 mma (testem3-V02-00-02 & testem-withHist)
- update of init.mac for new vis commands.
- G4UItcsh in the main()
	  
25th November 2000 Steve O'Neale (tagset210)
- Update test outputs for min.delta energy cut and table printout
- Update test outputs em tags 1 percent change in deposited energy

June 24, 2000  John Allison  (testem3-V01-01-01)
- Updated TestEm3.out for stand-V01-01-05 and utils-V01-01-03.

June 17, 2000  John Allison  (testem3-V01-00-00)
- Updated TestEm3.out for geant4-01-01-ref-06.
